(in-package :pong.client)

(defclass create-online-game-scene (scene)
  ((name :initform "" :accessor create-online-game-scene-name)
   (title :initarg :title :initform nil :reader create-online-game-scene-title)
   (name-field :initarg :name-field :initform nil :reader create-online-game-scene-name-field)
   (prompt :initarg :prompt :initform nil :reader create-online-game-scene-prompt)))

(defun open-create-online-game-scene ()
  (let ((root-element (gui:make-rectangle :color r:+darkgray+
					  :h-align :center
					  :v-align :middle))
	(title (gui:make-text :color r:+white+
			      :font *menu-font*
			      :font-size *menu-title-font-size*
			      :y *title-top-padding*
			      :h-align :center
			      :text "Create online game"))
	(name-field (gui:make-text :color r:+white+
				   :font *menu-font*
				   :font-size *menu-font-size*
				   :v-align :middle))
	(prompt (gui:make-text :color r:+white+
			       :font *menu-font*
			       :font-size *menu-font-size*
			       :h-align :right
			       :v-align :middle
			       :text "What is your name?:")))
    (gui:add-children root-element title name-field prompt)

    (set-scene (make-instance 'create-online-game-scene :root-element root-element
							:name-field name-field
							:title title
							:prompt prompt))))

(defmethod on-update ((scene create-online-game-scene) timelapse)
  (with-slots (name move-back) scene
    ;; Might be interesting to add repeating keys, but I don't care.
    (loop for key = (r:get-key-pressed)
	  while (plusp key)
	  when (= key r:+key-escape+)
	    do (open-main-menu)
	  when (= key r:+key-backspace+)
	    do (setf name (str:substring 0 -1 name))
	  when (= key r:+key-enter+)
	    do (create-online-game name)
	  when (and (>= key 32) (<= key 96))
	    do (setf name (str:concat name (string (code-char key)))))))

(defmethod on-draw ((scene create-online-game-scene))
  (with-slots (name root-element title name-field prompt) scene
    (position-root root-element)
    (setf (gui:x title) (floor (gui:w root-element) 2))
    (setf (gui:text name-field) name)
    (setf (gui:x name-field) (+ (floor (gui:w root-element) 2) *score-padding*))
    (setf (gui:x prompt) (- (floor (gui:w root-element) 2) *score-padding*))
    (setf (gui:y name-field) (floor (gui:h root-element) 2))
    (setf (gui:y prompt) (floor (gui:h root-element) 2))))
