(in-package #:gui)

(defclass line (element)
  ((end-x     :initarg :end-x     :initform 0.0 :accessor end-x)
   (end-y     :initarg :end-y     :initform 0.0 :accessor end-y)
   (thickness :initarg :thickness :initform 0.0 :accessor thickness)
   (color     :initarg :color     :initform r:+black+ :accessor color)))

(defmethod draw ((line line))
  (with-slots (screen-x screen-y x y end-x end-y thickness color visible) line
    (when visible
      (r:draw-line-ex (v:vec screen-x screen-y)
		      (v:vec (+ screen-x (- end-x x))
			     (+ screen-y (- end-y y)))
		      (float thickness)
		      color))))

(defmacro make-line (&rest args)
  `(make-instance 'line ,@args))
