(in-package :pong.game)

(defclass game-action-message ()
  ((game-code :initarg :game-code :initform nil :reader game-code)
   (game-action :initarg :game-action :initform nil :reader game-action)))

(defclass state-updated-message ()
  ((game-state :initarg :game-state :initform nil :reader game-state)))

(defclass create-game-message ()
  ((player-name :initarg :player-name :initform nil :reader player-name)))

(defclass join-game-message ()
  ((game-code :initarg :game-code :initform nil :reader game-code)
   (player-name :initarg :player-name :initform nil :reader player-name)))

(defclass game-created-message ()
  ((game-code :initarg :game-code :initform nil :reader game-code)
   (player-paddle :initarg :player-paddle :initform nil :reader player-paddle)
   (game-state :initarg :game-state :initform nil :reader game-state)))

(defclass game-joined-message ()
  ((player-paddle :initarg :player-paddle :initform nil :reader player-paddle)
   (game-state :initarg :game-state :initform nil :reader game-state)))

(defclass player-left-message ()
  ((player-name :initarg :player-name :initform nil :reader player-name)
   (game-state :initarg :game-state :initform nil :reader game-state)))

(defclass game-does-not-exist () ())
(defclass game-full () ())

(cpk:defencoding game-action-message game-code game-action)
(cpk:defencoding state-updated-message game-state)
(cpk:defencoding create-game-message player-name)
(cpk:defencoding join-game-message game-code player-name)
(cpk:defencoding game-created-message game-code player-paddle game-state)
(cpk:defencoding game-joined-message player-paddle game-state)
(cpk:defencoding player-left-message player-name game-state)
(cpk:defencoding game-does-not-exist)
(cpk:defencoding game-full)
